/** \file iso_com_network_receiver_protocol.h
 *
 *  Created by Daniel Bisig on 5/21/09.
 */

#ifndef _iso_com_network_receiver_protocol_h_
#define _iso_com_network_receiver_protocol_h_

#include "iso_com_network_protocol.h";
#include "iso_com_message_parser.h";
#include <QMutex>

namespace iso
{

namespace com 
{

class NetworkReceiverProtocol : public NetworkProtocol
{
public:
	NetworkReceiverProtocol(const base::String& pAddress, unsigned int pPort, unsigned int pMaxPacketSize);
	~NetworkReceiverProtocol();
	
	int lastPacketSize() const;
	bool bufferAvailable() const;
	virtual void removeAvailableBuffer();
	virtual void removeAllBuffers();
	const ByteBuffer& buffer() const throw (ComException);
	
	virtual void receive( const MessageParser& pParser ) throw (ComException) = 0;

protected:
	NetworkReceiverProtocol();
	
	int mPacketSize;
	ByteBuffer* mAvailableBuffer;
	
	QMutex mLock; ///\brief receiver lock
};	

};

};

#endif