/** \file iso_com_network_sender_protocol.h
 *
 *  Created by Daniel Bisig on 5/21/09.
 */

#ifndef _iso_com_network_sender_protocol_h_
#define _iso_com_network_sender_protocol_h_

#include "iso_com_network_protocol.h";
#include "iso_com_message_parser.h";
#include <QMutex>

namespace iso
{

namespace com 
{

class NetworkSenderProtocol : public NetworkProtocol
{
public:
	NetworkSenderProtocol(const base::String& pAddress, unsigned int pPort, unsigned int pMaxPacketSize);
	~NetworkSenderProtocol();
	
	virtual void send( const ByteBuffer& pByteBuffer, const MessageParser& pParser ) throw (ComException) = 0;

protected:
	NetworkSenderProtocol();
	
	QMutex mLock; ///\brief sender lock
};	

};

};

#endif