/** \file iso_event_listener.h
 *
 *  event notification is performed by the event manager class\n
 *  event notification happens in the moment of event creation and not in the moment of event execution\n
 *
 *  Created by Daniel Bisig on 5/26/07.
 */

#ifndef _iso_event_listener_h_
#define _iso_event_listener_h_

namespace iso
{

namespace event
{

class Event;

class EventListener
{
public:
	/**
	\brief event notification
	\param pEvent newly created event
	*/
	virtual void notify(Event* pEvent) = 0;
};

};

};

#endif