/** \file iso_geom_mesh_types.h
 *
 *  Created by Daniel Bisig on 8/8/07.
 */

#ifndef _iso_geom_mesh_types_h_
#define _iso_geom_mesh_types_h_

#include <OpenMesh/Core/IO/MeshIO.hh>
#include <OpenMesh/Core/Mesh/TriMesh_ArrayKernelT.hh>
#include <OpenMesh/Core/Mesh/PolyMesh_ArrayKernelT.hh>

namespace iso
{

namespace geom
{

struct MeshDefaultTraits : public OpenMesh::DefaultTraits 
{
	/*
	VertexAttributes( OpenMesh::Attributes::Normal | OpenMesh::Attributes::Status );
	EdgeAttributes( OpenMesh::Attributes::Status );
	FaceAttributes( OpenMesh::Attributes::Normal | OpenMesh::Attributes::Status );
	*/

	VertexAttributes( OpenMesh::Attributes::Normal );
	FaceAttributes( OpenMesh::Attributes::Normal );	
};

typedef OpenMesh::TriMesh_ArrayKernelT<MeshDefaultTraits>  DefaultMesh;
typedef OpenMesh::TriMesh_ArrayKernelT<MeshDefaultTraits>  TriMesh;
typedef OpenMesh::PolyMesh_ArrayKernelT<MeshDefaultTraits>  PolyMesh;

typedef TriMesh::Point Point;
typedef TriMesh::Normal Normal;

typedef TriMesh::Vertex Vertex;
typedef TriMesh::Edge Edge;
typedef TriMesh::Face Face;

typedef TriMesh::VertexHandle VertexHandle;
typedef TriMesh::EdgeHandle EdgeHandle;
typedef TriMesh::FaceHandle FaceHandle;

typedef TriMesh::VertexIter VertexIter;
typedef TriMesh::VertexVertexIter VertexVertexIter;
typedef TriMesh::VertexEdgeIter VertexEdgeIter;
typedef TriMesh::VertexFaceIter VertexFaceIter;
typedef TriMesh::EdgeIter EdgeIter;
typedef TriMesh::FaceIter FaceIter;
typedef TriMesh::FaceVertexIter FaceVertexIter;
typedef TriMesh::FaceEdgeIter FaceEdgeIter;
typedef TriMesh::FaceFaceIter FaceFaceIter;

};

};

#endif