/** \file iso_geom_spline_tools.h
 *
 *  Created by Daniel Bisig on 5/16/07.
 */

#ifndef _iso_geom_spline_tools_h_
#define _iso_geom_spline_tools_h_

#include "iso_geom_spline.h"
#include "iso_geom_spline_group.h"

namespace iso
{

namespace geom
{

class SplineTools
{
public:
	static SplineTools& get();
	static void destroy();

	void closestIndices(const math::Vector<real>& pRefPoint, QVector<int>& pResultIndices, SplineGroup& pSplineGroup);
	void closestPoints(const math::Vector<real>& pRefPoint, QVector< math::Vector<real> >& pResultPoints, SplineGroup& pSplineGroup);

	void closestIndices(const math::Vector<real>& pRefPoint, QVector<int>& pResultIndices, SplineGroup& pSplineGroup, QVector<int>& pStartIndices, QVector<int>& pEndIndices);
	void closestPoints(const math::Vector<real>& pRefPoint, QVector< math::Vector<real> >& pResultPoints, SplineGroup& pSplineGroup, QVector<int>& pStartIndices, QVector<int>& pEndIndices);

	void closestIndex(const math::Vector<real>& pRefPoint, int& pResultIndex, Spline& pSpline, int pStartIndex = -1, int pEndIndex = -1);
	void closestPoint(const math::Vector<real>& pRefPoint, math::Vector<real>& pResultPoint, Spline& pSpline, int pStartIndex = -1, int pEndIndex = -1);	

protected:
	SplineTools();
	~SplineTools();

	static SplineTools* sSplineTools;

};

};

};

#endif