/** \file iso_space_neighbor_group_shape_alg.h
 *
 *  Created by Daniel Bisig on 5/18/07.
 */

#ifndef _iso_space_neighbor_group_shape_alg_h_
#define _iso_space_neighbor_group_shape_alg_h_

#include "iso_space_neighbor_group_alg.h"
#include "iso_space_object.h"
#include "iso_space_neighbor_relation.h"
#include "iso_space_neighbor_group.h"

namespace iso
{

namespace space
{

class NeighborGroupShapeAlg : public NeighborGroupAlg
{
public:
	/**
	\brief create neighbor algorithm
	*/
	NeighborGroupShapeAlg();

	/**
	\brief create neighbor algorithm
	\param pNeighborRadius radius within which neighbors are searched
	\param pMaxNeighborCount maximum number of neighbors in neighbor list if >= 0 (-1: no limit)
	\param pReplaceNeighborMode replace more distant neighbors with closer neighbors if true
	*/
	NeighborGroupShapeAlg(real pNeighborRadius, int pMaxNeighborCount, bool pReplaceNeighborMode);
	
	/**
	\brief add Neighbor
	\param pObject1 the space object a neighbor will be added to
	\param pObject2 the neighbor space object
	\return whether neighbor has been created or not
	*/
	virtual bool createNeighbor(SpaceObject* pObject1, SpaceObject* pObject2);	
};

};

};

#endif